import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.*;
import java.sql.*;
import java.beans.*;
import java.text.*;

/**
 * This is the specific visual monitor info for Capture.
 *
 * @author tjacopi
 *
 */
public class CaptureInstanceMonitorPanel extends ReplInstanceMonitorPanel   {

    private   static final String CaptureInactiveMsg = "Capture Inactive";
    private   static final Color[] logLatencySegmentColors =  {Color.green };
    public    static final String AllCaptureLogs = "<all_logs>";
    public    static final String AllCaptureTP = "<all_TP>";


    public CaptureInstanceMonitorPanel(String capAlias, String uid, String pwd, String capSchema) {
      super(capAlias, uid, pwd, capSchema);
    }

    protected DataGatherer createDataGatherer() {
      return new CaptureDataGatherer(schema);
    }

    protected QMonitorPanel createQMonitorPanel(String queueName) {
      QMonitorPanel p = new QMonitorPanel(dataGatherer, queueName, logLatencySegmentColors, null);
      if (AllCaptureLogs.equals(queueName) ) {
        p.setTitle("DB2 Log Latency");
      } else if (AllCaptureTP.equals(queueName) ) {
        p.setTitle("Capture Throughput");
      };
      return p;
    }

    protected String getInactiveMsg() {
      return  CaptureInactiveMsg;
    }

    public Vector getAllQueues() {
      return getRecvQList(alias, schema, uid, pwd);
    }

    public static Vector getRecvQList(String alias, String schema, String uid, String pwd) {
      return new Vector();
    }

    public boolean  supportsMultipleGraphsInPanel() {
      return false;
    }

    protected void buildAdditionalMenuActions(Vector titles, Vector actionListeners) {
      return;         // No additional actions
    }

    public String getTraceQuery(boolean addParamForLastTime) {
      StringBuffer sb = new StringBuffer(100);
      sb.append("SELECT OPERATION, TRACE_TIME, DESCRIPTION FROM ");
      sb.append(schema);
      sb.append(".IBMSNAP_CAPTRACE ");
      if (addParamForLastTime) {
        sb.append(" WHERE TRACE_TIME > ?");
      };
      sb.append(" ORDER BY TRACE_TIME DESC ");

      return sb.toString();
    }

    public String getLatestTraceEntryQuery() {
      StringBuffer sb = new StringBuffer(100);
      sb.append("SELECT MAX(TRACE_TIME) FROM ");
      sb.append(schema);
      sb.append(".IBMSNAP_CAPTRACE ");

      return sb.toString();
    }

    public   String getTraceTitle() {
      return alias + "(" + schema + ")" + " Capture trace";
    }
}