import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.*;
import java.sql.*;
import java.beans.*;
import java.text.*;

/**
 * This is the specific visual monitor info for QCapture.
 *
 * @author tjacopi
 *
 */
public class QCaptureInstanceMonitorPanel extends ReplInstanceMonitorPanel   {

    private   static final String CaptureInactiveMsg = "QCapture Inactive";
    private   static final Color[] sendQLatencySegmentColors =  {Color.green };


    public QCaptureInstanceMonitorPanel(String capAlias, String uid, String pwd, String capSchema) {
      super(capAlias, uid, pwd, capSchema);
    }

    protected DataGatherer createDataGatherer() {
      return new QCaptureDataGatherer(schema);
    }

    protected QMonitorPanel createQMonitorPanel(String queueName) {
      QMonitorPanel p = new QMonitorPanel(dataGatherer, queueName, sendQLatencySegmentColors, null);
      if (queueName.equals(ReplInstanceMonitorPanel.AllQueues) ) {
        p.setTitle("DB2 Log Latency");
      };
      return p;
    }

    protected String getInactiveMsg() {
      return  CaptureInactiveMsg;
    }

    public Vector getAllQueues() {
      return getRecvQList(alias, schema, uid, pwd);
    }

    public static Vector getRecvQList(String alias, String schema, String uid, String pwd) {
      String listSQL = "SELECT DISTINCT SENDQ FROM " + schema+".IBMQREP_SENDQUEUES  ";
      return executeQueueList(listSQL, alias, schema, uid, pwd);
    }

    public boolean  supportsMultipleGraphsInPanel() {
      return false;        // only 1 graph per QMonitorPanel
    }

    protected void buildAdditionalMenuActions(Vector titles, Vector actionListeners) {
      titles.add("Add Queue");
      actionListeners.add( new AddQueueAction() );
    }

    public String getTraceQuery(boolean addParamForLastTime) {
      StringBuffer sb = new StringBuffer(100);
      sb.append("SELECT OPERATION, TRACE_TIME, DESCRIPTION FROM ");
      sb.append(schema);
      sb.append(".IBMQREP_CAPTRACE ");
      if (addParamForLastTime) {
        sb.append(" WHERE TRACE_TIME > ?");
      };
      sb.append(" ORDER BY TRACE_TIME DESC ");

      return sb.toString();
    }

    public String getLatestTraceEntryQuery() {
      StringBuffer sb = new StringBuffer(100);
      sb.append("SELECT MAX(TRACE_TIME) FROM ");
      sb.append(schema);
      sb.append(".IBMQREP_CAPTRACE ");

      return sb.toString();
    }

    public   String getTraceTitle() {
      return alias + "(" + schema + ")" + " QCapture trace";
    }
}