import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.util.*;


public class ReplPanelPopupMenu extends MouseAdapter implements ActionListener {
   private static final String ViewLatencyCmd = "viewLatency";
   private static final String ViewTPCmd = "viewTP";
   private static final String RemoveCmd = "remove";
   private static final String StartCmd = "start";
   private static final String StopCmd = "stop";
   private static final String AddMQQueueCmd = "addMQ";
   private static final String AddSchemaCmd = "addSchema";

   protected int xPopup = 0;
   protected int yPopup = 0;

   public ReplPanelPopupMenu() {
     ;
   }

    public void mouseReleased(MouseEvent e) {
      if (e.isPopupTrigger() && e.getComponent() instanceof Container) {
        Container container = (Container) e.getComponent();

        xPopup = e.getX();
        yPopup = e.getY();

        JPopupMenu popup = new JPopupMenu();
        JMenuItem mi;
        JMenuItem mi2;

        MonitorFrame parent = getParentFrame( container );
        ReplInstanceMonitorPanel monitorPanel = parent.getMonitorPanel();
        QMonitorPanel recvQPanel =  monitorPanel.getQPanelAt(xPopup, yPopup);

        if (monitorPanel.isRunning() ) {
          mi = new JMenuItem( "Stop" );
          mi.addActionListener(new StopAction() );
          popup.add(mi);
        } else {
          mi = new JMenuItem( "Start" );
          mi.addActionListener(new StartAction() );
          popup.add(mi);
        }
/*
        if (recvQPanel != null) {
          popup.addSeparator();
          mi = new JMenu( "View" );

          mi2 = new JCheckBoxMenuItem( "Latency", recvQPanel.isShowing(RecvQMonitorPanel.LatencyGraph)  );
          mi2.setActionCommand(ViewLatencyCmd);
          mi2.addActionListener(this);
          mi.add(mi2);
          mi2 = new JCheckBoxMenuItem( "Throughput", recvQPanel.isShowing(RecvQMonitorPanel.ThroughputGraph) );
          mi2.setActionCommand(ViewTPCmd);
          mi2.addActionListener(this);
          mi.add(mi2);
          popup.add(mi);
        };
 */
        popup.addSeparator();
        Vector customMenuItemTitles = monitorPanel.getCustomMenuItemTitles();
        if (customMenuItemTitles != null && customMenuItemTitles.size() >0)  {
          Vector customMenuItemListeners = monitorPanel.getCustomMenuItemListeners();
          for (int i=0;i<customMenuItemTitles.size(); i++) {
            mi2 = new JMenuItem( customMenuItemTitles.elementAt(i).toString() );
            ActionListener al = (ActionListener) customMenuItemListeners.elementAt(i);
            mi2.addActionListener( al );
            popup.add(mi2);
          }
        };

        mi = new JMenuItem( "Remove" );
        mi.setActionCommand(RemoveCmd);
        mi.addActionListener(this);
        popup.add(mi);
        container.add(popup);
        popup.show(container, e.getX(), e.getY());
     }

   }

   public void actionPerformed(final ActionEvent e) {
     MonitorFrame        parent = getParentFrame(e.getSource() );
     ReplInstanceMonitorPanel monitorPanel = parent.getMonitorPanel();
     QMonitorPanel        recvQPanel =  monitorPanel.getQPanelAt(xPopup, yPopup);
     String actionCommand = e.getActionCommand();
     if (RemoveCmd.equals(actionCommand) ) {
       String queueName = recvQPanel.getQueueName();
       boolean repack = monitorPanel.removeMonitoring(queueName);
       if (repack) {
         parent.pack();
       };
     } else if (ViewLatencyCmd.equals(actionCommand) ||
                ViewTPCmd.equals(actionCommand) ) {
       int graphType = 0;
       if (ViewLatencyCmd.equals(actionCommand) ) {
         graphType = QMonitorPanel.LatencyGraph;
       } else {
         graphType = QMonitorPanel.ThroughputGraph;
       }

       if ( recvQPanel.isShowing(graphType)  ) {
         recvQPanel.hide(graphType);
       } else {
         recvQPanel.show(graphType);
       }
       monitorPanel.invalidate();
       monitorPanel.validate();
     } else {
       JOptionPane.showMessageDialog(parent, "Function not yet supported");
     }
   }

   protected MonitorFrame getParentFrame(Object c ) {
     while( c != null && !(c instanceof MonitorFrame) ) {
       if (c instanceof JPopupMenu) {
         c = ((JPopupMenu) c).getInvoker();
       } else if (c instanceof Container) {
         c = ((Container) c).getParent();
       } else {
         c = null;
       }
     };
     return (MonitorFrame) c;
   }

}
