//**************************************Copyright 1997 IBM Corporation*
//
// Java Programming
// Exercise 4 (Client User Interface) Solution
// Change History:
//   04/08/97 BDW Updated to V1.1
//
//*********************************************************************

import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import java.util.*;

//  The main DB2 Command Processor applet.  Contains a command
//  input area and a message output area!

public class loadApply {

  protected static String[] applyQuals = { "APPLY1", "APPLY2", "APPLY3"};
  protected static String[] subSets = { "SET1", "SET2", "SET3"};

  protected static int counter = 0;
  protected static Random random = new Random( System.currentTimeMillis() );

   public static void main(String s[]) {
      try {
         // register the driver with DriverManager
         // The newInstance() call is needed for the sample to work with
         // JDK 1.1.1 on OS/2, where the Class.forName() method does not
         // run the static initializer. For other JDKs, the newInstance
         // call can be omitted.
         Timestamp sourceConnTime = new Timestamp( System.currentTimeMillis() );
         Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
         System.out.println("Connecting to db " + s[0] );
         //                  MONITOR_TIME, RECVQ, END2END_LATENCY, QLATENCY, APPLY_LATENCY,

         // apply_qual, set_name, set_inserted, set_deleted, set_updated
         String sql = "INSERT INTO ASN.IBMSNAP_APPLYTRAIL VALUES(?,?,'U','F','N','N',0,?,?,?," +

         // last_run, lastsuccess, synctime,
                                                                "0,0,0,?,?,'sync123',?,'SRCSVR','SRCALIAS','SRCOWNER'," +
                                                                "'SRCTABLE',0,'TGTSVR','TGTALIAS','TGTOWNER','TGTTABLE','ASN','ASN','FEDSRC','FEDTGT'," +

         // endtime, source_conn_time,
                                                                "'JLIB','JNAME',0,'NNNN','EVENT',?,?,'STATE',0,'ERRP'," +
                                                                "'ERRM','APPERRM') ";
         Connection con = connect("DB2", s[0], "tjacopi", "wof12wof");
         while  (counter<10000)  {
           for (int i=0; i<3; i++) {
             for (int j=0; j<3; j++) {
               int  capValue =  random.nextInt(500  );
               int  qValue     =  random.nextInt( 500  );
               int  applyValue     =  random.nextInt(  500 );
               int  rowInserted    =  random.nextInt( 500  );
               int  rowDeleted     =  random.nextInt( 500  );
               int  rowUpdated     =  random.nextInt( 500  );
               int  totalValue =  capValue + qValue + applyValue;
               Timestamp lastRun   = new Timestamp( System.currentTimeMillis() - 20000 - random.nextInt(80000) );
               Timestamp lastSuccess = new Timestamp( System.currentTimeMillis() - random.nextInt(10000) );
               Timestamp syncTime   = new Timestamp( System.currentTimeMillis() - random.nextInt(20000) );
               Timestamp endTime   = new Timestamp( System.currentTimeMillis() - random.nextInt(20000) );

               try {
                 PreparedStatement stmt = con.prepareStatement(sql);
                 stmt.setString(1, applyQuals[i]);
                 stmt.setString(2, subSets[j]);
                 stmt.setInt(3, rowInserted);
                 stmt.setInt(4, rowDeleted);
                 stmt.setInt(5, rowUpdated);
                 stmt.setTimestamp(6, lastRun);
                 stmt.setTimestamp(7, lastSuccess);
                 stmt.setTimestamp(8, syncTime);
                 stmt.setTimestamp(9, endTime);
                 stmt.setTimestamp(10, sourceConnTime);
                 int rowsUpdated = stmt.executeUpdate();
                 System.out.println("Rows updated is " + rowsUpdated);
                 stmt.close();
               } catch( Exception e ) {
                 e.printStackTrace();
               }
             }
           }

           Thread.currentThread().sleep(5000);
//         run(con, "INSERT INTO TOM2 VALUES(?, 'DEF' ) ");
//         run(con, "INSERT INTO TOM3 VALUES(?, 'GHI' ) ");
           counter++;
         }
         close(con);
       } catch (Exception e) {
         e.printStackTrace();
       }
   }

   public static Connection connect(String db2Instance, String db2Database, String userid, String password) {
     Connection con = null;
      try {
        // URL is jdbc:db2:dbname  -->  jdbc:<instance>:<dbname>
          String url = "jdbc:" + db2Instance + ":" + db2Database;
 //     String url = "jdbc:" + "uiiserver1:50000:"+db2Instance + ":" + db2Database;
        System.out.println("URL = " + url + "<<" );
        con = DriverManager.getConnection(url,userid,password);
      } catch( Exception e ) {
         e.printStackTrace();
      }
      return con;
   }

   public static void close(Connection con) {
     try {
       // Close DB2 connection
       System.out.println("Closing DB2 connection");
       if (con != null) con.close();
     } catch( Exception e ) {
        e.printStackTrace();
     }
   }


}